//
//  MainViewController.h
//  iFreeThePostcode
//
//  Created by John McKerrell on 21/10/2008.
//  Copyright MKE Computing Ltd 2008. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <CoreLocation/CoreLocation.h>
#import "PostCodeSubmitOperation.h"

@interface MainViewController : UIViewController {
    IBOutlet UILabel *latitude, *longitude, *accuracy, *lastUpdated;
    IBOutlet UITextField *pcFirst, *pcSecond, *emailAddress, *activeField;
    IBOutlet UITextView *accuracyMessage;
    IBOutlet UIButton *submitBtn, *testBtn, *linkBtn;
    IBOutlet UIActivityIndicatorView *activity;
    IBOutlet UIScrollView *scrollView;
    IBOutlet UIView *innerView;
    IBOutlet UISwitch *locationLock;
    CLLocation *currentLocation;
    BOOL updating, keyboardShown;
    NSOperationQueue *queue;
}

- (IBAction)textFieldDoneEditing:(id)sender;
- (IBAction)textFieldUpdated:(id)sender;
- (IBAction)textFieldBeganEditing:(id)sender;
- (IBAction)buttonClicked:(id)sender;
- (void)locationUpdated:(CLLocation*) newLocation;
- (void)updateViewStatus;
- (void)registerForKeyboardNotifications;
- (void)keyboardWasShown:(NSNotification*)aNotification;
- (void)keyboardWasHidden:(NSNotification*)aNotification;
- (void)submissionResponse:(NSString*)response;

@end
